#include <iostream>
using namespace std;
int main(int argc, char** argv) {
	ios_base::sync_with_stdio(false);
	long long int bin[31];
	bin[0]=1;
	for(long long int i=1;i<31;i++)
	{
		bin[i]=2*bin[i-1];
	}
	int n;
	cin >>n;
	long long int a[n+1][31];
	for(int i=0;i<31;i++)
	{
		a[0][i]=0;
	}
	for(int i=1;i<n+1;i++)
	{
		long long int x;
		cin >>x;
		for(int j=0;j<31;j++)
		{
			if(x&bin[j])
			{
				a[i][j]=a[i-1][j]+1;
			}
			else
			{
				a[i][j]=a[i-1][j];
			}	
		}
	}
	long long int b[n+1][31];
	for(int i=0;i<31;i++)
	{
		b[0][i]=0;
	}
	for(int i=1;i<n+1;i++)
	{
		long long int x;
		cin >>x;
		for(int j=0;j<31;j++)
		{
			if(x&bin[j])
			{
				b[i][j]=b[i-1][j]+1;
			}
			else
			{
				b[i][j]=b[i-1][j];
			}	
		}
	}
	
	unsigned long long int mx=0;
	for(int k=1;k<min(n,50);k++)
	{
		
		for(int i=0;i<n-k+1;i++)
		{
			unsigned long long int arez=0;
			for(int j=0;j<31;j++)
			{
				if((a[i+k][j]-a[i][j])&1)
				{
					arez+=bin[j];
				}
			}
			unsigned long long int brez=0;
			for(int j=0;j<31;j++)
			{
				if((b[i+k][j]-b[i][j])==k)
				{
					brez+=bin[j];
				}
			}
			mx=max(mx,arez*brez);
			
		}
	}
	cout <<mx<<"\n";
	return 0;
}